/*
  "Fire Emblem 6: Fuuin No Tsurugi" NonText Linker
  By Dark Twilkitri

  For linking files into the IPS which aren't part of the script, and thus don't have
  blocking information or pointers.

  Last Modified: 28/09/04
 */

/* Preprocessor */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Function Prototypes */


/* Globals */


/* Main */
int main(int argc, char* argv[])
{
	/* Locals */
	char *data;
	FILE *datafile;
	FILE *ips;
	int   datalen;
	int   targoffset;

	if(argc != 3)
	{
		printf("linkex usage:\n  linkex datafile offset\n    datafile - file to link in.\n    offset - where to link it.\n");
		return 1;
	}

	//open IPS file
	ips = fopen("fe8e.ips", "a+b");
	if(!ips)
	{
		printf("Could not open IPS file to add data.\n");
		return 1;
	}

	//go to end of file
	fseek(ips, 0, SEEK_END);

	//open datafile
	datafile = fopen(argv[1], "rb");
	if(!datafile)
	{
		printf("Could not open data file \"%s\".\n", argv[1]);
		fclose(ips);
		return 1;
	}

	targoffset = strtol(argv[2], NULL, 16);

	fseek(datafile, 0, SEEK_END);
	datalen = ftell(datafile);
	fseek(datafile, 0, SEEK_SET);

	data = (char*)malloc(datalen);

	fread(data, 1, datalen, datafile);

	//add data pointer to IPS
	fputc((targoffset & 0xFF0000) >> 16, ips);
	fputc((targoffset & 0x00FF00) >> 8, ips);
	fputc((targoffset & 0x0000FF), ips);

	//add size to IPS
	fputc((datalen & 0xFF00) >> 8, ips);
	fputc(datalen & 0x00FF, ips);

	//add data to IPS

	fwrite(data, 1, datalen, ips);

	free(data);
	fclose(datafile);
	fclose(ips);
	return 0;
}