/*
  "Fire Emblem 6: Fuuin No Tsurugi" Automated Patch Builder
  By Dark Twilkitri

  Negates the need to run four+ different programs.

  Last Modified: 21/01/05
 */

/* Preprocessor */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Function Prototypes */


/* Globals */


/* Main */
int main(int argc, char* argv[])
{
	/* Locals */
	char *arglist;
	char *arglistpure;
	char *command;
	FILE *ips;
	int   arglistlen;
	int   arglistpurelen;
	int   i;
	int   pureargs = 0;

	if(argc < 2)
	{
		printf("make usage:\n  make script1 [script2] [...]\n");
		return 1;
	}

	arglistlen = arglistpurelen = 1;

	for(i = 1; i < argc; i++)
	{
		if(strcmp(argv[i], "-pure"))
			arglistlen += (int)(strlen(argv[i]) + 1);
		else //curarg is "-pure"
		{
			pureargs = 1;
			break;
		}
	}

	if(arglistlen < 40)
		arglistlen = 40; //why did I do this?

	arglist = (char*)malloc(arglistlen);
	arglist[0] = '\0';

	if(pureargs)
	{
        for(++i; i < argc; i++)
			arglistpurelen += (int)(strlen(argv[i]) + 1);
		
		if(arglistpurelen < 40)
			arglistpurelen = 40;

		arglistpure = (char*)malloc(arglistpurelen);
		arglistpure[0] = '\0';
	}



	for(i = 1; (i < argc) && strcmp(argv[i], "-pure"); i++)
	{
		strcat(arglist, " ");
		strcat(arglist, argv[i]);
	}

	if(pureargs)
		for(++i; i < argc; i++)
		{
			strcat(arglistpure, " ");
			strcat(arglistpure, argv[i]);
		}

	command = (char*)malloc(arglistlen + 10 + (pureargs ? arglistpurelen : 0));
	
	printf("Parsing normal scripts...\n");
	command[0] = '\0';
	strcat(command, "parse");
	strcat(command, arglist);
	system(command);

	if(pureargs)
	{
		printf("Parsing puretext scripts...\n");
		command[0] = '\0';
		strcat(command, "pureparse");
		strcat(command, arglistpure);
		system(command);
	}

	printf("Optimising normal scripts...\n");
	command[0] = '\0';
	strcat(command, "optidte");
	strcat(command, arglist);
	system(command);

	printf("Generating Huffman Table...\n");
	command[0] = '\0';
	strcat(command, "retable");
	strcat(command, arglist);
	system(command);

	printf("Encoding scripts...\n");
	command[0] = '\0';
	strcat(command, "encode");
	strcat(command, arglist);
	system(command);

	printf("Allocating space...\n");
	command[0] = '\0';
	strcat(command, "alloc");
	strcat(command, arglist);
	if(pureargs)
		strcat(command, arglistpure);
	system(command);

	printf("Creating IPS...\n");
	printf("Adding scripts...\n");
	command[0] = '\0';
	strcat(command, "link");
	strcat(command, arglist);
	if(pureargs)
		strcat(command, arglistpure);
	system(command);

	printf("Adding Huffman table...\n");
	command[0] = '\0';
	strcat(command, "linkex");
	strcat(command, " fe8e.tbl 0x15A72C");
	system(command);

	free(arglist);
	free(arglistpure);
	free(command);

	//add the EOF string to the IPS
	ips = fopen("fe8e.ips", "a+b");
	if(!ips)
	{
		printf("Could not open IPS file.\n");
		return 1;
	}
	fputc('E', ips);
	fputc('O', ips);
	fputc('F', ips);

	fclose(ips);
	return 0;
}